unit OneToManyServerDMU;

interface

uses
  Windows, Messages, SysUtils, Classes, ComServ, ComObj, VCLCom, DataBkr,
  DBClient, OneToManyServer_TLB, StdVcl, Provider, Db, DBTables;

type
  TCustomerData = class(TRemoteDataModule, ICustomerData)
    tblCustomer: TTable;
    tblOrders: TTable;
    dsCustomer: TDataSource;
    dspCustomer: TDataSetProvider;
  private
    { Private declarations }
  protected
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

class procedure TCustomerData.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

initialization
  TComponentFactory.Create(ComServer, TCustomerData,
    Class_CustomerData, ciMultiInstance, tmApartment);
end.
